Index: BOOK/stylesheets/pdf/lfs-xref.xsl
===================================================================
--- BOOK/stylesheets/pdf/lfs-xref.xsl	(revision 02095ae2677b1a04865e7362509b6a5c1647e4e2)
+++ BOOK/stylesheets/pdf/lfs-xref.xsl	(revision 02095ae2677b1a04865e7362509b6a5c1647e4e2)
@@ -0,0 +1,283 @@
+<?xml version='1.0' encoding='ISO-8859-1'?>
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns:fo="http://www.w3.org/1999/XSL/Format"
+                version="1.0">
+
+     <!-- Making a proper punctuation in xref (only for English language).-->
+  <xsl:template match="xref" name="xref">
+    <xsl:variable name="targets" select="key('id',@linkend)"/>
+    <xsl:variable name="target" select="$targets[1]"/>
+    <xsl:variable name="refelem" select="local-name($target)"/>
+    <xsl:variable name="role" select="@role"/>
+    <xsl:call-template name="check.id.unique">
+      <xsl:with-param name="linkend" select="@linkend"/>
+    </xsl:call-template>
+    <xsl:choose>
+      <xsl:when test="$refelem=''">
+        <xsl:message>
+          <xsl:text>XRef to nonexistent id: </xsl:text>
+          <xsl:value-of select="@linkend"/>
+        </xsl:message>
+        <xsl:text>???</xsl:text>
+      </xsl:when>
+      <xsl:when test="$target/@xreflabel">
+        <fo:basic-link internal-destination="{@linkend}"
+                      xsl:use-attribute-sets="xref.properties">
+          <xsl:call-template name="xref.xreflabel">
+            <xsl:with-param name="target" select="$target"/>
+          </xsl:call-template>
+        </fo:basic-link>
+      </xsl:when>
+      <xsl:otherwise>
+        <fo:basic-link internal-destination="{@linkend}"
+                      xsl:use-attribute-sets="xref.properties">
+          <xsl:apply-templates select="$target" mode="xref-to">
+            <xsl:with-param name="referrer" select="."/>
+            <xsl:with-param name="role" select="$role"/>
+            <xsl:with-param name="xrefstyle">
+              <xsl:value-of select="@xrefstyle"/>
+            </xsl:with-param>
+          </xsl:apply-templates>
+        </fo:basic-link>
+      </xsl:otherwise>
+    </xsl:choose>
+    <!-- Add standard page reference? -->
+    <xsl:if test="not(starts-with(normalize-space(@xrefstyle), 'select:') != ''
+                  and (contains(@xrefstyle, 'page')
+                      or contains(@xrefstyle, 'Page')))
+                  and ( $insert.xref.page.number = 'yes'
+        or $insert.xref.page.number = '1')
+                  or local-name($target) = 'para'">
+      <fo:basic-link internal-destination="{@linkend}"
+                    xsl:use-attribute-sets="xref.properties">
+        <xsl:apply-templates select="$target" mode="page.citation">
+          <xsl:with-param name="id" select="@linkend"/>
+        </xsl:apply-templates>
+      </fo:basic-link>
+    </xsl:if>
+  </xsl:template>
+
+  <xsl:template match="section|simplesect|sect1|sect2|sect3|sect4|sect5
+                      |refsect1|refsect2|refsect3|refsection" mode="xref-to">
+    <xsl:param name="referrer"/>
+    <xsl:param name="xrefstyle"/>
+    <xsl:param name="role"/>
+    <xsl:apply-templates select="." mode="object.xref.markup">
+      <xsl:with-param name="purpose" select="'xref'"/>
+      <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
+      <xsl:with-param name="referrer" select="$referrer"/>
+      <xsl:with-param name="role" select="$role"/>
+    </xsl:apply-templates>
+  </xsl:template>
+
+  <xsl:template match="*" mode="object.xref.markup">
+    <xsl:param name="purpose"/>
+    <xsl:param name="xrefstyle"/>
+    <xsl:param name="referrer"/>
+    <xsl:param name="role"/>
+    <xsl:variable name="template">
+      <xsl:choose>
+        <xsl:when test="starts-with(normalize-space($xrefstyle), 'select:')">
+          <xsl:call-template name="make.gentext.template">
+            <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
+            <xsl:with-param name="purpose" select="$purpose"/>
+            <xsl:with-param name="referrer" select="$referrer"/>
+          </xsl:call-template>
+        </xsl:when>
+        <xsl:when test="starts-with(normalize-space($xrefstyle), 'template:')">
+          <xsl:value-of select="substring-after(normalize-space($xrefstyle), 'template:')"/>
+        </xsl:when>
+        <xsl:otherwise>
+          <xsl:apply-templates select="." mode="object.xref.template">
+            <xsl:with-param name="purpose" select="$purpose"/>
+            <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
+            <xsl:with-param name="referrer" select="$referrer"/>
+          </xsl:apply-templates>
+        </xsl:otherwise>
+      </xsl:choose>
+    </xsl:variable>
+    <xsl:if test="$template = ''">
+      <xsl:message>
+        <xsl:text>object.xref.markup: empty xref template</xsl:text>
+        <xsl:text> for linkend="</xsl:text>
+        <xsl:value-of select="@id"/>
+        <xsl:text>" and @xrefstyle="</xsl:text>
+        <xsl:value-of select="$xrefstyle"/>
+        <xsl:text>"</xsl:text>
+      </xsl:message>
+    </xsl:if>
+    <xsl:call-template name="substitute-markup">
+      <xsl:with-param name="purpose" select="$purpose"/>
+      <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
+      <xsl:with-param name="referrer" select="$referrer"/>
+      <xsl:with-param name="template" select="$template"/>
+      <xsl:with-param name="role" select="$role"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <xsl:template name="substitute-markup">
+    <xsl:param name="template" select="''"/>
+    <xsl:param name="allow-anchors" select="'0'"/>
+    <xsl:param name="title" select="''"/>
+    <xsl:param name="subtitle" select="''"/>
+    <xsl:param name="label" select="''"/>
+    <xsl:param name="pagenumber" select="''"/>
+    <xsl:param name="purpose"/>
+    <xsl:param name="xrefstyle"/>
+    <xsl:param name="referrer"/>
+    <xsl:param name="role"/>
+    <xsl:choose>
+      <xsl:when test="contains($template, '%')">
+        <xsl:value-of select="substring-before($template, '%')"/>
+        <xsl:variable name="candidate"
+              select="substring(substring-after($template, '%'), 1, 1)"/>
+        <xsl:choose>
+          <xsl:when test="$candidate = 't'">
+            <xsl:apply-templates select="." mode="insert.title.markup">
+              <xsl:with-param name="purpose" select="$purpose"/>
+              <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
+              <xsl:with-param name="role" select="$role"/>
+              <xsl:with-param name="title">
+                <xsl:choose>
+                  <xsl:when test="$title != ''">
+                    <xsl:copy-of select="$title"/>
+                  </xsl:when>
+                  <xsl:otherwise>
+                    <xsl:apply-templates select="." mode="title.markup">
+                      <xsl:with-param name="allow-anchors" select="$allow-anchors"/>
+                    </xsl:apply-templates>
+                  </xsl:otherwise>
+                </xsl:choose>
+              </xsl:with-param>
+            </xsl:apply-templates>
+          </xsl:when>
+          <xsl:when test="$candidate = 's'">
+            <xsl:apply-templates select="." mode="insert.subtitle.markup">
+              <xsl:with-param name="purpose" select="$purpose"/>
+              <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
+              <xsl:with-param name="subtitle">
+                <xsl:choose>
+                  <xsl:when test="$subtitle != ''">
+                    <xsl:copy-of select="$subtitle"/>
+                  </xsl:when>
+                  <xsl:otherwise>
+                    <xsl:apply-templates select="." mode="subtitle.markup">
+                      <xsl:with-param name="allow-anchors" select="$allow-anchors"/>
+                    </xsl:apply-templates>
+                  </xsl:otherwise>
+                </xsl:choose>
+              </xsl:with-param>
+            </xsl:apply-templates>
+          </xsl:when>
+          <xsl:when test="$candidate = 'n'">
+            <xsl:apply-templates select="." mode="insert.label.markup">
+              <xsl:with-param name="purpose" select="$purpose"/>
+              <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
+              <xsl:with-param name="label">
+                <xsl:choose>
+                  <xsl:when test="$label != ''">
+                    <xsl:copy-of select="$label"/>
+                  </xsl:when>
+                  <xsl:otherwise>
+                    <xsl:apply-templates select="." mode="label.markup"/>
+                  </xsl:otherwise>
+                </xsl:choose>
+              </xsl:with-param>
+            </xsl:apply-templates>
+          </xsl:when>
+          <xsl:when test="$candidate = 'p'">
+            <xsl:apply-templates select="." mode="insert.pagenumber.markup">
+              <xsl:with-param name="purpose" select="$purpose"/>
+              <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
+              <xsl:with-param name="pagenumber">
+                <xsl:choose>
+                  <xsl:when test="$pagenumber != ''">
+                    <xsl:copy-of select="$pagenumber"/>
+                  </xsl:when>
+                  <xsl:otherwise>
+                    <xsl:apply-templates select="." mode="pagenumber.markup"/>
+                  </xsl:otherwise>
+                </xsl:choose>
+              </xsl:with-param>
+            </xsl:apply-templates>
+          </xsl:when>
+          <xsl:when test="$candidate = 'd'">
+            <xsl:apply-templates select="." mode="insert.direction.markup">
+              <xsl:with-param name="purpose" select="$purpose"/>
+              <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
+              <xsl:with-param name="direction">
+                <xsl:choose>
+                  <xsl:when test="$referrer">
+                    <xsl:variable name="referent-is-below">
+                      <xsl:for-each select="preceding::xref">
+                        <xsl:if test="generate-id(.) = generate-id($referrer)">1</xsl:if>
+                      </xsl:for-each>
+                    </xsl:variable>
+                    <xsl:choose>
+                      <xsl:when test="$referent-is-below = ''">
+                        <xsl:call-template name="gentext">
+                          <xsl:with-param name="key" select="'above'"/>
+                        </xsl:call-template>
+                      </xsl:when>
+                      <xsl:otherwise>
+                        <xsl:call-template name="gentext">
+                          <xsl:with-param name="key" select="'below'"/>
+                        </xsl:call-template>
+                      </xsl:otherwise>
+                    </xsl:choose>
+                  </xsl:when>
+                  <xsl:otherwise>
+                    <xsl:message>Attempt to use %d in gentext with no referrer!</xsl:message>
+                  </xsl:otherwise>
+                </xsl:choose>
+              </xsl:with-param>
+            </xsl:apply-templates>
+          </xsl:when>
+          <xsl:when test="$candidate = '%' ">
+            <xsl:text>%</xsl:text>
+          </xsl:when>
+          <xsl:otherwise>
+            <xsl:text>%</xsl:text><xsl:value-of select="$candidate"/>
+          </xsl:otherwise>
+        </xsl:choose>
+        <!-- recurse with the rest of the template string -->
+        <xsl:variable name="rest"
+              select="substring($template,
+              string-length(substring-before($template, '%'))+3)"/>
+        <xsl:call-template name="substitute-markup">
+          <xsl:with-param name="template" select="$rest"/>
+          <xsl:with-param name="allow-anchors" select="$allow-anchors"/>
+          <xsl:with-param name="title" select="$title"/>
+          <xsl:with-param name="subtitle" select="$subtitle"/>
+          <xsl:with-param name="label" select="$label"/>
+          <xsl:with-param name="pagenumber" select="$pagenumber"/>
+          <xsl:with-param name="purpose" select="$purpose"/>
+          <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
+          <xsl:with-param name="referrer" select="$referrer"/>
+          <xsl:with-param name="role" select="$role"/>
+        </xsl:call-template>
+      </xsl:when>
+      <xsl:otherwise>
+        <xsl:value-of select="$template"/>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:template>
+
+  <xsl:template match="*" mode="insert.title.markup">
+    <xsl:param name="purpose"/>
+    <xsl:param name="xrefstyle"/>
+    <xsl:param name="title"/>
+    <xsl:param name="role"/>
+    <xsl:choose>
+      <xsl:when test="$purpose = 'xref' and titleabbrev">
+        <xsl:apply-templates select="." mode="titleabbrev.markup"/>
+      </xsl:when>
+      <xsl:otherwise>
+        <xsl:copy-of select="$title"/>
+        <xsl:value-of select="$role"/>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: BOOK/stylesheets/top-index.xsl
===================================================================
--- BOOK/stylesheets/top-index.xsl	(revision 4fc026ef671b8cdd8c60814e135dc362072ac718)
+++ BOOK/stylesheets/top-index.xsl	(revision 02095ae2677b1a04865e7362509b6a5c1647e4e2)
@@ -15,14 +15,13 @@
       <head>
         <title>
-          Cross-Compiled Linux From Scratch - Sysroot
+          Linux From Scratch
         </title>
         <style type="text/css">
           <xsl:text>
-/* Global settings */
 body {
-  font-family: verdana, tahoma, helvetica, arial, sans-serif;
+  font-family: sans-serif;
   text-align: left;
   background: #fff;
-  color: #222;
+  color: #333;
   margin: 1em;
   padding: 0;
@@ -32,29 +31,36 @@
 
 a:link { color: #22b; }
-a.ulink:link { font-weight: bold; color: #55f; }
-a:visited { color: #7e4988 ! important; }
-a:hover, a:focus { color: #d30e08 ! important; }
-a:active { color: #6b77b1 ! important;}
+a:visited { color: #7e4988; }
+a:hover, a:focus { color: #d30e08; }
+a:active { color: #6b77b1;}
 
-h1, h2 h3, h4 {
+h1, h2 {
   color: #000;
   font-weight: bold;
-  line-height: 1em;
+}
+
+h3, h4, h5, h6 {
+  color: #222;
 }
 
 h1 { font-size: 173%; text-align: center; }
-h2 { font-size: 144%; text-align: center; }
-h3 { font-size: 120%; }
-h4 { font-size: 110%; }
+h2 { font-size: 144%;  text-align: center; }
+h3 { font-size: 120%; padding-top: 0.2em; margin-top: 0.3em; }
+h4 { font-size: 110%;}
 
-.toc {
+div.toc {
   padding-left: 1em;
+  margin-top: 1em;
 }
 
-.toc ul li h3, .toc ul li h4 {
+div.toc ul li h3, div.toc ul li h4 {
   margin: .4em;
 }
 
-.book h1 {
+div.book {
+  padding-bottom: 0.5em;
+}
+
+div.book h1 {
   background: #f5f6f7;
   margin: 0px auto;
@@ -62,13 +68,13 @@
 }
 
-.book h2 {
+div.book h2 {
   background: #dbddec;
   margin: 0px auto;
   padding: 0.2em;
 }
-.author, .copyright {
+div.authorgroup, div p.copyright {
   background: #f5f6f7;
   margin: 0px auto;
-  padding: 0.5em 1em;
+  padding:  1em 0.5em;
 }
 
@@ -97,7 +103,10 @@
       <div class="toc">
         <h3>
-          <xsl:text>32 Bit Builds (Under Development)</xsl:text>
+          <xsl:text>32 Bit Builds</xsl:text>
         </h3>
         <ul>
+	  <h3>
+	    <xsl:text>Under Development.</xsl:text>
+          </h3>
           <li>
             <h4>
@@ -107,31 +116,11 @@
             </h4>
           </li>
-          <li>
-            <h4>
-              <a href="x86">
-                <xsl:text>X86</xsl:text>
-              </a>
-            </h4>
-          </li>
-          <li>
-            <h4>
-              <a href="hppa">
-                <xsl:text>PA-RISC</xsl:text>
-              </a>
-            </h4>
-          </li>
         </ul>
         <h3>
-          <xsl:text>64 Bit Builds (Under Development)</xsl:text>
+          <xsl:text>64 Bit Builds</xsl:text>
         </h3>
-        <ul>
-          <li>
-            <h4>
-              <a href="alpha">
-                <xsl:text>Alpha</xsl:text>
-              </a>
-            </h4>
-          </li>
-        </ul>
+        <h3>
+          <xsl:text>Multilib Builds</xsl:text>
+        </h3>
       </div>
     </div>
@@ -139,35 +128,38 @@
 
   <xsl:template match="title">
-    <h1 class="title">
-      <xsl:value-of select="."/>
-    </h1>
-    <h2 class="subtitle">
-      <xsl:text>Version &version;</xsl:text>
-    </h2>
+    <div>
+      <h1 class="title">
+        <xsl:value-of select="."/>
+      </h1>
+    </div>
+    <div>
+      <h2 class="subtitle">
+        <xsl:text>Version &version;</xsl:text>
+      </h2>
+    </div>
   </xsl:template>
 
   <xsl:template match="authorgroup">
-    <h3 class="author">
-      <xsl:value-of select="author[1]/firstname"/>
-      <xsl:text> </xsl:text>
-      <xsl:value-of select="author[1]/surname"/>
-    </h3>
-    <h3 class="author">
-      <xsl:value-of select="author[2]/firstname"/>
-      <xsl:text> </xsl:text>
-      <xsl:value-of select="author[2]/surname"/>
-    </h3>
-    <h3 class="author">
-      <xsl:value-of select="author[3]/firstname"/>
-      <xsl:text> </xsl:text>
-      <xsl:value-of select="author[3]/surname"/>
-    </h3>
+    <div class="authorgroup">
+      <h3 class="author">
+        <xsl:value-of select="author[1]/firstname"/>
+        <xsl:text> </xsl:text>
+        <xsl:value-of select="author[1]/surname"/>
+      </h3>
+      <h3 class="author">
+        <xsl:value-of select="author[2]/firstname"/>
+        <xsl:text> </xsl:text>
+        <xsl:value-of select="author[2]/surname"/>
+      </h3>
+    </div>
   </xsl:template>
 
   <xsl:template match="copyright">
-    <p class="copyright">
-      <xsl:text>Copyright ©</xsl:text>
-      <xsl:apply-templates/>
-    </p>
+    <div>
+      <p class="copyright">
+        <xsl:text>Copyright (c)</xsl:text>
+        <xsl:apply-templates/>
+      </p>
+    </div>
   </xsl:template>
 
@@ -181,9 +173,11 @@
 
   <xsl:template match="bibliosource">
-    <p class="copyright">
-      <em>
-        <xsl:apply-templates/>
-      </em>
-    </p>
+    <div>
+      <p class="copyright">
+        <em>
+          <xsl:apply-templates/>
+        </em>
+      </p>
+    </div>
   </xsl:template>
 
Index: BOOK/stylesheets/wget.xsl
===================================================================
--- BOOK/stylesheets/wget.xsl	(revision 4fc026ef671b8cdd8c60814e135dc362072ac718)
+++ BOOK/stylesheets/wget.xsl	(revision 02095ae2677b1a04865e7362509b6a5c1647e4e2)
@@ -26,5 +26,5 @@
       <!-- Packages. If some package don't have the string ".tar." in their
       name, the next test must be fixed to match it also. -->
-    <xsl:if test="contains(@url, '.tar.') or contains(@url, '.tgz')">
+    <xsl:if test="contains(@url, '.tar.')">
       <xsl:value-of select="@url"/>
       <xsl:text>&#x0a;</xsl:text>
Index: BOOK/stylesheets/xhtml/lfs-admon.xsl
===================================================================
--- BOOK/stylesheets/xhtml/lfs-admon.xsl	(revision 02095ae2677b1a04865e7362509b6a5c1647e4e2)
+++ BOOK/stylesheets/xhtml/lfs-admon.xsl	(revision 02095ae2677b1a04865e7362509b6a5c1647e4e2)
@@ -0,0 +1,46 @@
+<?xml version='1.0' encoding='ISO-8859-1'?>
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns="http://www.w3.org/1999/xhtml"
+                version="1.0">
+
+    <!-- Use graphics in admonitions -->
+  <xsl:param name="admon.graphics" select="1"/>
+  <xsl:param name="admon.graphics.path">../images/</xsl:param>
+  <xsl:param name="admon.graphics.extension" select="'.png'"/>
+
+    <!-- Changing the output tagging -->
+  <xsl:template name="graphical.admonition">
+    <xsl:variable name="admon.type">
+      <xsl:choose>
+        <xsl:when test="local-name(.)='note'">Note</xsl:when>
+        <xsl:when test="local-name(.)='warning'">Warning</xsl:when>
+        <xsl:when test="local-name(.)='caution'">Caution</xsl:when>
+        <xsl:when test="local-name(.)='tip'">Tip</xsl:when>
+        <xsl:when test="local-name(.)='important'">Important</xsl:when>
+        <xsl:otherwise>Note</xsl:otherwise>
+      </xsl:choose>
+    </xsl:variable>
+    <xsl:variable name="alt">
+      <xsl:call-template name="gentext">
+        <xsl:with-param name="key" select="$admon.type"/>
+      </xsl:call-template>
+    </xsl:variable>
+    <div class="{name(.)}">
+      <div class ="admonhead">
+        <img alt="[{$alt}]">
+          <xsl:attribute name="src">
+            <xsl:call-template name="admon.graphic"/>
+          </xsl:attribute>
+        </img>
+        <h3 class="admontitle">
+          <xsl:apply-templates select="." mode="object.title.markup"/>
+        </h3>
+      </div>
+      <div class="admonbody">
+        <xsl:apply-templates/>
+      </div>
+    </div>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: BOOK/stylesheets/xhtml/lfs-index.xsl
===================================================================
--- BOOK/stylesheets/xhtml/lfs-index.xsl	(revision 02095ae2677b1a04865e7362509b6a5c1647e4e2)
+++ BOOK/stylesheets/xhtml/lfs-index.xsl	(revision 02095ae2677b1a04865e7362509b6a5c1647e4e2)
@@ -0,0 +1,202 @@
+<?xml version='1.0' encoding='ISO-8859-1'?>
+<!DOCTYPE xsl:stylesheet [
+<!ENTITY lowercase "'abcdefghijklmnopqrstuvwxyz'">
+<!ENTITY uppercase "'ABCDEFGHIJKLMNOPQRSTUVWXYZ'">
+<!ENTITY primary   'normalize-space(concat(primary/@sortas, primary[not(@sortas)]))'>
+<!ENTITY scope 'count(ancestor::node()|$scope) = count(ancestor::node())'>
+]>
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns="http://www.w3.org/1999/xhtml"
+                version="1.0">
+
+    <!--Filename-->
+  <xsl:template match="index" mode="recursive-chunk-filename">
+    <xsl:text>longindex.html</xsl:text>
+  </xsl:template>
+
+    <!--Title-->
+  <xsl:param name="index-title">Index</xsl:param>
+
+  <xsl:template match="index" mode="title.markup">
+    <xsl:call-template name="gentext">
+      <xsl:with-param name="key" select="$index-title"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <xsl:template name="index.titlepage">
+    <div class="titlepage">
+      <h1 class="index">
+        <xsl:call-template name="gentext">
+          <xsl:with-param name="key" select="$index-title"/>
+        </xsl:call-template>
+      </h1>
+    </div>
+  </xsl:template>
+
+    <!--Divisions-->
+  <xsl:template match="indexterm" mode="index-div">
+    <xsl:param name="scope" select="."/>
+    <xsl:variable name="key" select="translate(substring(&primary;, 1, 1),&lowercase;,&uppercase;)"/>
+    <xsl:variable name="divtitle" select="translate($key, &lowercase;, &uppercase;)"/>
+      <!-- Make sure that we don't generate a div if there are no terms in scope -->
+    <xsl:if test="key('letter', $key)[&scope;] [count(.|key('primary', &primary;)[&scope;][1]) = 1]">
+      <div class="indexdiv">
+        <xsl:if test="contains(concat(&lowercase;, &uppercase;), $key)">
+          <h2>
+            <xsl:choose>
+              <xsl:when test="$divtitle = 'A'">
+                <xsl:call-template name="gentext">
+                  <xsl:with-param name="key">Packages</xsl:with-param>
+                </xsl:call-template>
+             </xsl:when>
+             <xsl:when test="$divtitle = 'B'">
+                <xsl:call-template name="gentext">
+                  <xsl:with-param name="key">Programs</xsl:with-param>
+                </xsl:call-template>
+             </xsl:when>
+             <xsl:when test="$divtitle = 'C'">
+                <xsl:call-template name="gentext">
+                  <xsl:with-param name="key">Libraries</xsl:with-param>
+                </xsl:call-template>
+             </xsl:when>
+             <xsl:when test="$divtitle = 'D'">
+                <xsl:call-template name="gentext">
+                  <xsl:with-param name="key">Scripts</xsl:with-param>
+                </xsl:call-template>
+             </xsl:when>
+              <xsl:when test="$divtitle = 'E'">
+                <xsl:call-template name="gentext">
+                  <xsl:with-param name="key">Others</xsl:with-param>
+                </xsl:call-template>
+              </xsl:when>
+             <xsl:otherwise>
+              <xsl:value-of select="$divtitle"/>
+            </xsl:otherwise>
+           </xsl:choose>
+          </h2>
+        </xsl:if>
+        <ul>
+          <xsl:apply-templates select="key('letter', $key)[&scope;]
+                  [count(.|key('primary', &primary;)[&scope;][1])=1]" mode="index-primary">
+            <xsl:with-param name="scope" select="$scope"/>
+            <xsl:sort select="translate(&primary;, &lowercase;, &uppercase;)"/>
+          </xsl:apply-templates>
+        </ul>
+      </div>
+    </xsl:if>
+  </xsl:template>
+
+    <!-- Dropping the separator from here-->
+  <xsl:template match="indexterm" mode="reference">
+    <xsl:param name="scope" select="."/>
+      <xsl:call-template name="reference">
+        <xsl:with-param name="zones" select="normalize-space(@zone)"/>
+        <xsl:with-param name="scope" select="$scope"/>
+      </xsl:call-template>
+  </xsl:template>
+
+    <!-- Changing the output tags and re-addind the separator-->
+  <xsl:template match="indexterm" mode="index-primary">
+    <xsl:param name="scope" select="."/>
+    <xsl:variable name="key" select="&primary;"/>
+    <xsl:variable name="refs" select="key('primary', $key)[&scope;]"/>
+    <li>
+      <strong class="item">
+        <xsl:value-of select="primary"/>
+        <xsl:text>: </xsl:text>
+      </strong>
+      <xsl:for-each select="$refs[generate-id() = generate-id(key('primary-section',
+              concat($key, &#34; &#34;, generate-id((ancestor-or-self::book |ancestor-or-self::part
+              |ancestor-or-self::chapter |ancestor-or-self::appendix |ancestor-or-self::preface
+              |ancestor-or-self::sect1 |ancestor-or-self::sect2 |ancestor-or-self::sect3
+              |ancestor-or-self::sect4 |ancestor-or-self::sect5 |ancestor-or-self::index)[last()])))[&scope;][1])]">
+        <xsl:apply-templates select="." mode="reference">
+          <xsl:with-param name="scope" select="$scope"/>
+        </xsl:apply-templates>
+      </xsl:for-each>
+      <xsl:if test="$refs/secondary">
+        <ul>
+          <xsl:apply-templates select="$refs[secondary and count(.|key('secondary',
+                  concat($key, &#34; &#34;, normalize-space(concat(secondary/@sortas,
+                  secondary[not(@sortas)]))))[&scope;][1]) = 1]" mode="index-secondary">
+            <xsl:with-param name="scope" select="$scope"/>
+            <xsl:sort select="translate(normalize-space(concat(secondary/@sortas,
+                    secondary[not(@sortas)])), &lowercase;, &uppercase;)"/>
+          </xsl:apply-templates>
+         </ul>
+      </xsl:if>
+    </li>
+  </xsl:template>
+
+  <xsl:template match="indexterm" mode="index-secondary">
+    <xsl:param name="scope" select="."/>
+    <xsl:variable name="key" select="concat(&primary;, &#34; &#34;,
+            normalize-space(concat(secondary/@sortas, secondary[not(@sortas)])))"/>
+    <xsl:variable name="refs" select="key('secondary', $key)[&scope;]"/>
+    <li>
+      <strong class="secitem">
+        <xsl:value-of select="secondary"/>
+        <xsl:text>: </xsl:text>
+      </strong>
+      <xsl:for-each select="$refs[generate-id() = generate-id(key('secondary-section',
+              concat($key, &#34; &#34;, generate-id((ancestor-or-self::book |ancestor-or-self::part
+              |ancestor-or-self::chapter |ancestor-or-self::appendix |ancestor-or-self::preface
+              |ancestor-or-self::sect1 |ancestor-or-self::sect2 |ancestor-or-self::sect3
+              |ancestor-or-self::sect4 |ancestor-or-self::sect5 |ancestor-or-self::index)[last()])))[&scope;][1])]">
+        <xsl:apply-templates select="." mode="reference">
+          <xsl:with-param name="scope" select="$scope"/>
+        </xsl:apply-templates>
+      </xsl:for-each>
+    </li>
+  </xsl:template>
+
+    <!--Links (This template also fix a bug in the original code)-->
+  <xsl:template name="reference">
+    <xsl:param name="scope" select="."/>
+    <xsl:param name="zones"/>
+    <xsl:choose>
+      <xsl:when test="contains($zones, ' ')">
+        <xsl:variable name="zone" select="substring-before($zones, ' ')"/>
+        <xsl:variable name="zone2" select="substring-after($zones, ' ')"/>
+        <xsl:variable name="target" select="key('sections', $zone)[&scope;]"/>
+        <xsl:variable name="target2" select="key('sections', $zone2)[&scope;]"/>
+        <a>
+          <xsl:attribute name="href">
+            <xsl:call-template name="href.target.uri">
+              <xsl:with-param name="object" select="$target[1]"/>
+            </xsl:call-template>
+          </xsl:attribute>
+          <xsl:apply-templates select="$target[1]" mode="index-title-content"/>
+        </a>
+        <xsl:text> -- </xsl:text>
+        <a>
+          <xsl:attribute name="href">
+            <xsl:call-template name="href.target.uri">
+              <xsl:with-param name="object" select="$target2[1]"/>
+            </xsl:call-template>
+          </xsl:attribute>
+          <xsl:call-template name="gentext">
+            <xsl:with-param name="key">description</xsl:with-param>
+          </xsl:call-template>
+        </a>
+      </xsl:when>
+      <xsl:otherwise>
+        <xsl:variable name="zone" select="$zones"/>
+        <xsl:variable name="target" select="key('sections', $zone)[&scope;]"/>
+        <a>
+          <xsl:attribute name="href">
+            <xsl:call-template name="href.target.uri">
+              <xsl:with-param name="object" select="$target[1]"/>
+            </xsl:call-template>
+          </xsl:attribute>
+          <xsl:apply-templates select="$target[1]" mode="index-title-content"/>
+        </a>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:template>
+
+    <!-- Dropping unneeded anchors -->
+  <xsl:template match="indexterm"/>
+
+</xsl:stylesheet>
